package com.brilliance.isc.fxtssb.service;

import com.brilliance.isc.common.contants.CommonContants;
import com.brilliance.isc.common.transaction.AbstractTransactionService;
import com.brilliance.isc.common.vo.BizAmdInfoVo;
import com.brilliance.isc.common.vo.BizInfoVo;
import com.brilliance.isc.funds.bo.funds.FxtssbStoreBo;
import com.brilliance.isc.fxtssb.check.FxtssbValidator;
import org.springframework.stereotype.Service;

import javax.annotation.PostConstruct;
import javax.annotation.Resource;
import java.util.Map;

/**
 * @program: isc-funds
 * @ClassName: FxtssbTransactionServiceImpl
 * @description: 即期结汇 Fxtssb 业务处理
 * @author: huangshunlin
 * @create: 2024-10-08 15:35
 */
@Service("fxtssb.transaction")
public class FxtssbTransactionServiceImpl extends AbstractTransactionService<FxtssbStoreBo> {

    @Resource
    private FxtssbValidator fxtssbValidator;


    @PostConstruct
    public void regisertService() {
        serviceRegisterMaps.put(CommonContants.SETMOD_SERVICE, "Y");
        serviceRegisterMaps.put(CommonContants.TRNDOC_SERVICE, "Y");
        serviceRegisterMaps.put(CommonContants.GLEMOD_SERVICE, "Y");
        serviceRegisterMaps.put(CommonContants.TRNDIA_SERVICE, "Y");
        serviceRegisterMaps.put(CommonContants.TRNMOD_SERVICE, "Y");
        serviceRegisterMaps.put(CommonContants.UMDMOD_SERVICE, "N");
        serviceRegisterMaps.put(CommonContants.LIMMOD_SERVICE, "Y");
        serviceRegisterMaps.put(CommonContants.BOPSET_RMB_SERVICE, "Y");
        serviceRegisterMaps.put(CommonContants.BOPSET_SZSB_BOPREM_SERVICE, "Y");
        serviceRegisterMaps.put(CommonContants.BOPSET_CFABOP_SERVICE, "Y");
        serviceRegisterMaps.put(CommonContants.FANXIQIAN_SERVICE, "Y");
    }


    @Override
    protected void txnSave(FxtssbStoreBo transactionVo) {
        ruleMtabutSavN500(transactionVo);
    }

    public void ruleMtabutSavN500(FxtssbStoreBo bo) {
    }

    @Override
    protected Map<String, String> txnCheck(FxtssbStoreBo transactionVo) {
        return fxtssbValidator.validate(transactionVo);
    }

    @Override
    protected BizInfoVo buildBizInfo(FxtssbStoreBo transactionVo) {

        return null;
    }

    @Override
    protected BizAmdInfoVo buildBizAmdInfo(FxtssbStoreBo transactionVo) {
        return null;
    }

    @Override
    public FxtssbStoreBo init(FxtssbStoreBo fxtssbStoreBo) {
        fxtssbStoreBo.reset();

        return fxtssbStoreBo;
    }

    @Override
    public void beforeSave(FxtssbStoreBo transactionVo) {
        transactionVo.reset();

    }

    @Override
    protected void updateBizInfoVo(BizInfoVo bizInfoVo, FxtssbStoreBo transactionVo) {
    }


}
